"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Puck = void 0;
var device_controller_1 = require("./device-controller");
var funcToString_1 = require("./helpers/funcToString");
var puck_types_1 = require("./types/puck-types");
var Puck = /** @class */ (function (_super) {
    __extends(Puck, _super);
    function Puck() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.pin = {
            val: function () {
                throw new Error('Function not implemented.');
            },
            onHigh: function (pin, func) {
                throw new Error('Function not implemented.');
            },
        };
        _this.mag = {
            enable: function () {
                throw new Error('Function not implemented.');
            },
            disabled: function () {
                throw new Error('Function not implemented.');
            },
            onMag: function () {
                throw new Error('Function not implemented.');
            },
            onField: function () {
                throw new Error('Function not implemented.');
            },
        };
        _this.accel = {
            enable: function () {
                throw new Error('Function not implemented.');
            },
            disable: function () {
                throw new Error('Function not implemented.');
            },
            val: function () {
                throw new Error('Function not implemented.');
            },
            onAccel: function (func) {
                throw new Error('Function not implemented.');
            },
            onMove: function (func) {
                throw new Error('Function not implemented.');
            },
            onSignificantMove: function (func) {
                throw new Error('Function not implemented.');
            },
            stepCount: {
                enable: function () {
                    throw new Error('Function not implemented.');
                },
                disable: function () {
                    throw new Error('Function not implemented.');
                },
                get: function () {
                    throw new Error('Function not implemented.');
                },
            },
        };
        _this.IR = {
            set: function (data) {
                throw new Error('Function not implemented.');
            },
            reset: function () {
                throw new Error('Function not implemented.');
            },
        };
        _this.LED = {
            /**
             *
             * @param color LED Colour to be turned on
             */
            on: function (color) {
                Array.isArray(color)
                    ? _this.UART.write("digitalWrite(".concat(color, ", 1)"))
                    : _this.UART.write("LED".concat(puck_types_1.LEDColours.indexOf(color) + 1, ".set();\n"));
            },
            /**
             *
             * @param color LED Colour to be turned off
             */
            off: function (color) {
                Array.isArray(color)
                    ? _this.UART.write("digitalWrite(".concat(color, ", 0)"))
                    : _this.UART.write("LED".concat(puck_types_1.LEDColours.indexOf(color) + 1, ".reset();\n"));
            },
            /**
             *
             * @param color LED Colour to be toggled
             */
            toggle: function (color) {
                _this.UART.write("LED".concat(puck_types_1.LEDColours.indexOf(color) + 1, ".toggle();\n"));
            },
            /**
             *
             * @param color LED Colour to be flashed
             * @param ms time for LED to be flashed
             */
            flash: function (color, ms) {
                _this.UART.write("digitalPulse(LED".concat(puck_types_1.LEDColours.indexOf(color) + 1, ",1,").concat(ms, ");\n"));
            },
            /**
             *
             * @param color LED colour to grab info from
             * @returns a boolean regarding if the LED is on or off
             */
            val: function (color) {
                return _this.eval("digitalRead(LED".concat(puck_types_1.LEDColours.indexOf(color) + 1, ") == 1"));
            },
        };
        _this.NFC = {
            /**
             *
             * @param url the url to be used as the new NFC value
             */
            setUrl: function (url) { return _this.UART.write('NRF.nfcURL("' + url + '");\n'); },
            reset: function () { return _this.UART.write('NRF.nfcURL();\n'); },
        };
        return _this;
    }
    Puck.prototype.getLightVal = function () {
        throw new Error('Method not implemented.');
    };
    /**
     *
     * @returns temperature from device
     */
    Puck.prototype.getTemperature = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.eval("E.getTemperature()")];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    /**
     *
     * @param func A function to be run of press of pucks button
     */
    Puck.prototype.onPress = function (func) {
        this.UART.write("\n    setWatch(function(){\n      ".concat((0, funcToString_1.stringifyFunction)(func), ";\n    }, BTN,{edge:\"rising\", repeat:true, debounce:50})\n  "));
    };
    /**
     *
     * @param long The function to be called on a long press
     * @param short The function to be called on a short press
     * @param ms the time required to consider a press a long press
     */
    Puck.prototype.onTimedPress = function (long, short, ms) {
        if (ms === void 0) { ms = 0.3; }
        this.UART.write("\n      setWatch(function(){\n        var ms = (e.time = e.lastTime);\n\n        if(ms > ".concat(ms, "){\n          ").concat((0, funcToString_1.stringifyFunction)(long), ";\n        } else {\n          ").concat((0, funcToString_1.stringifyFunction)(short), ";\n        }\n      }, BTN,{edge:\"falling\", repeat:true, debounce:50})\n    "));
    };
    return Puck;
}(device_controller_1.DeviceController));
exports.Puck = Puck;
